require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_ACPI_H)) {
    eval 'sub _ASM_ACPI_H () {1;}' unless defined(&_ASM_ACPI_H);
    if(defined(&__KERNEL__)) {
	require 'linux/init.ph';
	require 'linux/numa.ph';
	require 'asm/system.ph';
	eval 'sub COMPILER_DEPENDENT_INT64 () {\'long\';}' unless defined(&COMPILER_DEPENDENT_INT64);
	eval 'sub COMPILER_DEPENDENT_UINT64 () {\'unsigned long\';}' unless defined(&COMPILER_DEPENDENT_UINT64);
	eval 'sub ACPI_SYSTEM_XFACE () {1;}' unless defined(&ACPI_SYSTEM_XFACE);
	eval 'sub ACPI_EXTERNAL_XFACE () {1;}' unless defined(&ACPI_EXTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_XFACE () {1;}' unless defined(&ACPI_INTERNAL_XFACE);
	eval 'sub ACPI_INTERNAL_VAR_XFACE () {1;}' unless defined(&ACPI_INTERNAL_VAR_XFACE);
	eval 'sub ACPI_ASM_MACROS () {1;}' unless defined(&ACPI_ASM_MACROS);
	eval 'sub BREAKPOINT3 () {1;}' unless defined(&BREAKPOINT3);
	eval 'sub ACPI_DISABLE_IRQS () {
	    eval q( &local_irq_disable());
	}' unless defined(&ACPI_DISABLE_IRQS);
	eval 'sub ACPI_ENABLE_IRQS () {
	    eval q( &local_irq_enable());
	}' unless defined(&ACPI_ENABLE_IRQS);
	eval 'sub ACPI_FLUSH_CPU_CACHE () {
	    eval q();
	}' unless defined(&ACPI_FLUSH_CPU_CACHE);
	eval 'sub ia64_acpi_acquire_global_lock {
	    my($lock) = @_;
    	    eval q({ my $old,  &new,  &val;  &do {  $old = *$lock;  &new = ((( $old & ~0x3) + 2) + (( $old >> 1) & 0x1));  &val =  &ia64_cmpxchg4_acq($lock,  &new,  $old); }  &while ( &unlikely ( &val !=  $old)); ( &new < 3) ? -1: 0; });
	}' unless defined(&ia64_acpi_acquire_global_lock);
	eval 'sub ia64_acpi_release_global_lock {
	    my($lock) = @_;
    	    eval q({ my $old,  &new,  &val;  &do {  $old = *$lock;  &new =  $old & ~0x3;  &val =  &ia64_cmpxchg4_acq($lock,  &new,  $old); }  &while ( &unlikely ( &val !=  $old));  $old & 0x1; });
	}' unless defined(&ia64_acpi_release_global_lock);
	eval 'sub ACPI_ACQUIRE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q((($Acq) =  &ia64_acpi_acquire_global_lock( $GLptr)));
	}' unless defined(&ACPI_ACQUIRE_GLOBAL_LOCK);
	eval 'sub ACPI_RELEASE_GLOBAL_LOCK {
	    my($GLptr, $Acq) = @_;
    	    eval q((($Acq) =  &ia64_acpi_release_global_lock( $GLptr)));
	}' unless defined(&ACPI_RELEASE_GLOBAL_LOCK);
	eval 'sub acpi_disabled () {0;}' unless defined(&acpi_disabled);
	eval 'sub acpi_noirq () {0;}' unless defined(&acpi_noirq);
	eval 'sub acpi_pci_disabled () {0;}' unless defined(&acpi_pci_disabled);
	eval 'sub acpi_strict () {1;}' unless defined(&acpi_strict);
	if(defined(&CONFIG_ACPI_NUMA)) {
	    if((defined(&MAX_NUMNODES) ? &MAX_NUMNODES : 0) > 256) {
		eval 'sub MAX_PXM_DOMAINS () { &MAX_NUMNODES;}' unless defined(&MAX_PXM_DOMAINS);
	    } else {
		eval 'sub MAX_PXM_DOMAINS () {(256);}' unless defined(&MAX_PXM_DOMAINS);
	    }
	}
	eval 'sub ACPI_PDC_EST_CAPABILITY_SMP () {0x8;}' unless defined(&ACPI_PDC_EST_CAPABILITY_SMP);
    }
}
1;
