require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_BITOPS_H)) {
    eval 'sub _ASM_IA64_BITOPS_H () {1;}' unless defined(&_ASM_IA64_BITOPS_H);
    require 'linux/compiler.ph';
    require 'linux/types.ph';
    require 'asm/intrinsics.ph';
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &do { ; }  &while (0));
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub test_bit {
        my($nr,$addr) = @_;
	    eval q({ 1& ((( &const  &volatile  &__u32 *) $addr)[$nr >> 5] >> ($nr & 31)); });
    }' unless defined(&test_bit);
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/fls64.ph';
	eval 'sub ffs {
	    my($x) = @_;
    	    eval q( &__builtin_ffs($x));
	}' unless defined(&ffs);
	eval 'sub hweight32 {
	    my($x) = @_;
    	    eval q(  &hweight64(($x) & 0xffffffff));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    my($x) = @_;
    	    eval q(  &hweight64(($x) & 0xffff));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    my($x) = @_;
    	    eval q(  &hweight64(($x) & 0xff));
	}' unless defined(&hweight8);
    }
    require 'asm-generic/bitops/find.ph';
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/ext2-non-atomic.ph';
	eval 'sub ext2_set_bit_atomic {
	    my($l,$n,$a) = @_;
    	    eval q( &test_and_set_bit($n,$a));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    my($l,$n,$a) = @_;
    	    eval q( &test_and_clear_bit($n,$a));
	}' unless defined(&ext2_clear_bit_atomic);
	require 'asm-generic/bitops/minix.ph';
	require 'asm-generic/bitops/sched.ph';
    }
}
1;
