require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_MACHVEC_H)) {
    eval 'sub _ASM_IA64_MACHVEC_H () {1;}' unless defined(&_ASM_IA64_MACHVEC_H);
    require 'linux/types.ph';
    eval 'sub machvec_noop {
        my($void) = @_;
	    eval q({ });
    }' unless defined(&machvec_noop);
    eval 'sub machvec_noop_mm {
        my($mm) = @_;
	    eval q({ });
    }' unless defined(&machvec_noop_mm);
    eval 'sub machvec_noop_task {
        my($task) = @_;
	    eval q({ });
    }' unless defined(&machvec_noop_task);
    if(defined ( &CONFIG_IA64_HP_SIM)) {
	require 'asm/machvec_hpsim.ph';
    }
 elsif(defined ( &CONFIG_IA64_DIG)) {
	require 'asm/machvec_dig.ph';
    }
 elsif(defined ( &CONFIG_IA64_HP_ZX1)) {
	require 'asm/machvec_hpzx1.ph';
    }
 elsif(defined ( &CONFIG_IA64_HP_ZX1_SWIOTLB)) {
	require 'asm/machvec_hpzx1_swiotlb.ph';
    }
 elsif(defined ( &CONFIG_IA64_SGI_SN2)) {
	require 'asm/machvec_sn2.ph';
    }
 elsif(defined ( &CONFIG_IA64_GENERIC)) {
	if(defined(&MACHVEC_PLATFORM_HEADER)) {
	} else {
	    eval 'sub platform_name () { ($ia64_mv->{name});}' unless defined(&platform_name);
	    eval 'sub platform_setup () { ($ia64_mv->{setup});}' unless defined(&platform_setup);
	    eval 'sub platform_cpu_init () { ($ia64_mv->{cpu_init});}' unless defined(&platform_cpu_init);
	    eval 'sub platform_irq_init () { ($ia64_mv->{irq_init});}' unless defined(&platform_irq_init);
	    eval 'sub platform_send_ipi () { ($ia64_mv->{send_ipi});}' unless defined(&platform_send_ipi);
	    eval 'sub platform_timer_interrupt () { ($ia64_mv->{timer_interrupt});}' unless defined(&platform_timer_interrupt);
	    eval 'sub platform_global_tlb_purge () { ($ia64_mv->{global_tlb_purge});}' unless defined(&platform_global_tlb_purge);
	    eval 'sub platform_tlb_migrate_finish () { ($ia64_mv->{tlb_migrate_finish});}' unless defined(&platform_tlb_migrate_finish);
	    eval 'sub platform_dma_init () { ($ia64_mv->{dma_init});}' unless defined(&platform_dma_init);
	    eval 'sub platform_dma_alloc_coherent () { ($ia64_mv->{dma_alloc_coherent});}' unless defined(&platform_dma_alloc_coherent);
	    eval 'sub platform_dma_free_coherent () { ($ia64_mv->{dma_free_coherent});}' unless defined(&platform_dma_free_coherent);
	    eval 'sub platform_dma_map_single () { ($ia64_mv->{dma_map_single});}' unless defined(&platform_dma_map_single);
	    eval 'sub platform_dma_unmap_single () { ($ia64_mv->{dma_unmap_single});}' unless defined(&platform_dma_unmap_single);
	    eval 'sub platform_dma_map_sg () { ($ia64_mv->{dma_map_sg});}' unless defined(&platform_dma_map_sg);
	    eval 'sub platform_dma_unmap_sg () { ($ia64_mv->{dma_unmap_sg});}' unless defined(&platform_dma_unmap_sg);
	    eval 'sub platform_dma_sync_single_for_cpu () { ($ia64_mv->{dma_sync_single_for_cpu});}' unless defined(&platform_dma_sync_single_for_cpu);
	    eval 'sub platform_dma_sync_sg_for_cpu () { ($ia64_mv->{dma_sync_sg_for_cpu});}' unless defined(&platform_dma_sync_sg_for_cpu);
	    eval 'sub platform_dma_sync_single_for_device () { ($ia64_mv->{dma_sync_single_for_device});}' unless defined(&platform_dma_sync_single_for_device);
	    eval 'sub platform_dma_sync_sg_for_device () { ($ia64_mv->{dma_sync_sg_for_device});}' unless defined(&platform_dma_sync_sg_for_device);
	    eval 'sub platform_dma_mapping_error () { ($ia64_mv->{dma_mapping_error});}' unless defined(&platform_dma_mapping_error);
	    eval 'sub platform_dma_supported () { ($ia64_mv->{dma_supported});}' unless defined(&platform_dma_supported);
	    eval 'sub platform_local_vector_to_irq () { ($ia64_mv->{local_vector_to_irq});}' unless defined(&platform_local_vector_to_irq);
	    eval 'sub platform_pci_get_legacy_mem () { ($ia64_mv->{pci_get_legacy_mem});}' unless defined(&platform_pci_get_legacy_mem);
	    eval 'sub platform_pci_legacy_read () { ($ia64_mv->{pci_legacy_read});}' unless defined(&platform_pci_legacy_read);
	    eval 'sub platform_pci_legacy_write () { ($ia64_mv->{pci_legacy_write});}' unless defined(&platform_pci_legacy_write);
	    eval 'sub platform_inb () { ($ia64_mv->{inb});}' unless defined(&platform_inb);
	    eval 'sub platform_inw () { ($ia64_mv->{inw});}' unless defined(&platform_inw);
	    eval 'sub platform_inl () { ($ia64_mv->{inl});}' unless defined(&platform_inl);
	    eval 'sub platform_outb () { ($ia64_mv->{outb});}' unless defined(&platform_outb);
	    eval 'sub platform_outw () { ($ia64_mv->{outw});}' unless defined(&platform_outw);
	    eval 'sub platform_outl () { ($ia64_mv->{outl});}' unless defined(&platform_outl);
	    eval 'sub platform_mmiowb () { ($ia64_mv->{mmiowb});}' unless defined(&platform_mmiowb);
	    eval 'sub platform_readb () { ($ia64_mv->{readb});}' unless defined(&platform_readb);
	    eval 'sub platform_readw () { ($ia64_mv->{readw});}' unless defined(&platform_readw);
	    eval 'sub platform_readl () { ($ia64_mv->{readl});}' unless defined(&platform_readl);
	    eval 'sub platform_readq () { ($ia64_mv->{readq});}' unless defined(&platform_readq);
	    eval 'sub platform_readb_relaxed () { ($ia64_mv->{readb_relaxed});}' unless defined(&platform_readb_relaxed);
	    eval 'sub platform_readw_relaxed () { ($ia64_mv->{readw_relaxed});}' unless defined(&platform_readw_relaxed);
	    eval 'sub platform_readl_relaxed () { ($ia64_mv->{readl_relaxed});}' unless defined(&platform_readl_relaxed);
	    eval 'sub platform_readq_relaxed () { ($ia64_mv->{readq_relaxed});}' unless defined(&platform_readq_relaxed);
	    eval 'sub platform_migrate () { ($ia64_mv->{migrate});}' unless defined(&platform_migrate);
	    eval 'sub platform_msi_init () { ($ia64_mv->{msi_init});}' unless defined(&platform_msi_init);
	}
	eval 'sub MACHVEC_INIT {
	    my($name) = @_;
    	    eval q({ $name,  &platform_setup,  &platform_cpu_init,  &platform_irq_init,  &platform_send_ipi,  &platform_timer_interrupt,  &platform_global_tlb_purge,  &platform_tlb_migrate_finish,  &platform_dma_init,  &platform_dma_alloc_coherent,  &platform_dma_free_coherent,  &platform_dma_map_single,  &platform_dma_unmap_single,  &platform_dma_map_sg,  &platform_dma_unmap_sg,  &platform_dma_sync_single_for_cpu,  &platform_dma_sync_sg_for_cpu,  &platform_dma_sync_single_for_device,  &platform_dma_sync_sg_for_device,  &platform_dma_mapping_error,  &platform_dma_supported,  &platform_local_vector_to_irq,  &platform_pci_get_legacy_mem,  &platform_pci_legacy_read,  &platform_pci_legacy_write,  &platform_inb,  &platform_inw,  &platform_inl,  &platform_outb,  &platform_outw,  &platform_outl,  &platform_mmiowb,  &platform_readb,  &platform_readw,  &platform_readl,  &platform_readq,  &platform_readb_relaxed,  &platform_readw_relaxed,  &platform_readl_relaxed,  &platform_readq_relaxed,  &platform_migrate,  &platform_msi_init, });
	}' unless defined(&MACHVEC_INIT);
    } else {
	die("Unknown\ configuration\.\ \ Update\ asm\-ia64\/machvec\.h\.");
    }
    unless(defined(&platform_setup)) {
	eval 'sub platform_setup () { &machvec_setup;}' unless defined(&platform_setup);
    }
    unless(defined(&platform_cpu_init)) {
	eval 'sub platform_cpu_init () { &machvec_noop;}' unless defined(&platform_cpu_init);
    }
    unless(defined(&platform_irq_init)) {
	eval 'sub platform_irq_init () { &machvec_noop;}' unless defined(&platform_irq_init);
    }
    unless(defined(&platform_send_ipi)) {
	eval 'sub platform_send_ipi () { &ia64_send_ipi;}' unless defined(&platform_send_ipi);
    }
    unless(defined(&platform_timer_interrupt)) {
	eval 'sub platform_timer_interrupt () { &machvec_timer_interrupt;}' unless defined(&platform_timer_interrupt);
    }
    unless(defined(&platform_global_tlb_purge)) {
	eval 'sub platform_global_tlb_purge () { &ia64_global_tlb_purge;}' unless defined(&platform_global_tlb_purge);
    }
    unless(defined(&platform_tlb_migrate_finish)) {
	eval 'sub platform_tlb_migrate_finish () { &machvec_noop_mm;}' unless defined(&platform_tlb_migrate_finish);
    }
    unless(defined(&platform_dma_init)) {
	eval 'sub platform_dma_init () { &swiotlb_init;}' unless defined(&platform_dma_init);
    }
    unless(defined(&platform_dma_alloc_coherent)) {
	eval 'sub platform_dma_alloc_coherent () { &swiotlb_alloc_coherent;}' unless defined(&platform_dma_alloc_coherent);
    }
    unless(defined(&platform_dma_free_coherent)) {
	eval 'sub platform_dma_free_coherent () { &swiotlb_free_coherent;}' unless defined(&platform_dma_free_coherent);
    }
    unless(defined(&platform_dma_map_single)) {
	eval 'sub platform_dma_map_single () { &swiotlb_map_single;}' unless defined(&platform_dma_map_single);
    }
    unless(defined(&platform_dma_unmap_single)) {
	eval 'sub platform_dma_unmap_single () { &swiotlb_unmap_single;}' unless defined(&platform_dma_unmap_single);
    }
    unless(defined(&platform_dma_map_sg)) {
	eval 'sub platform_dma_map_sg () { &swiotlb_map_sg;}' unless defined(&platform_dma_map_sg);
    }
    unless(defined(&platform_dma_unmap_sg)) {
	eval 'sub platform_dma_unmap_sg () { &swiotlb_unmap_sg;}' unless defined(&platform_dma_unmap_sg);
    }
    unless(defined(&platform_dma_sync_single_for_cpu)) {
	eval 'sub platform_dma_sync_single_for_cpu () { &swiotlb_sync_single_for_cpu;}' unless defined(&platform_dma_sync_single_for_cpu);
    }
    unless(defined(&platform_dma_sync_sg_for_cpu)) {
	eval 'sub platform_dma_sync_sg_for_cpu () { &swiotlb_sync_sg_for_cpu;}' unless defined(&platform_dma_sync_sg_for_cpu);
    }
    unless(defined(&platform_dma_sync_single_for_device)) {
	eval 'sub platform_dma_sync_single_for_device () { &swiotlb_sync_single_for_device;}' unless defined(&platform_dma_sync_single_for_device);
    }
    unless(defined(&platform_dma_sync_sg_for_device)) {
	eval 'sub platform_dma_sync_sg_for_device () { &swiotlb_sync_sg_for_device;}' unless defined(&platform_dma_sync_sg_for_device);
    }
    unless(defined(&platform_dma_mapping_error)) {
	eval 'sub platform_dma_mapping_error () { &swiotlb_dma_mapping_error;}' unless defined(&platform_dma_mapping_error);
    }
    unless(defined(&platform_dma_supported)) {
	eval 'sub platform_dma_supported () { &swiotlb_dma_supported;}' unless defined(&platform_dma_supported);
    }
    unless(defined(&platform_local_vector_to_irq)) {
	eval 'sub platform_local_vector_to_irq () { &__ia64_local_vector_to_irq;}' unless defined(&platform_local_vector_to_irq);
    }
    unless(defined(&platform_pci_get_legacy_mem)) {
	eval 'sub platform_pci_get_legacy_mem () { &ia64_pci_get_legacy_mem;}' unless defined(&platform_pci_get_legacy_mem);
    }
    unless(defined(&platform_pci_legacy_read)) {
	eval 'sub platform_pci_legacy_read () { &ia64_pci_legacy_read;}' unless defined(&platform_pci_legacy_read);
    }
    unless(defined(&platform_pci_legacy_write)) {
	eval 'sub platform_pci_legacy_write () { &ia64_pci_legacy_write;}' unless defined(&platform_pci_legacy_write);
    }
    unless(defined(&platform_inb)) {
	eval 'sub platform_inb () { &__ia64_inb;}' unless defined(&platform_inb);
    }
    unless(defined(&platform_inw)) {
	eval 'sub platform_inw () { &__ia64_inw;}' unless defined(&platform_inw);
    }
    unless(defined(&platform_inl)) {
	eval 'sub platform_inl () { &__ia64_inl;}' unless defined(&platform_inl);
    }
    unless(defined(&platform_outb)) {
	eval 'sub platform_outb () { &__ia64_outb;}' unless defined(&platform_outb);
    }
    unless(defined(&platform_outw)) {
	eval 'sub platform_outw () { &__ia64_outw;}' unless defined(&platform_outw);
    }
    unless(defined(&platform_outl)) {
	eval 'sub platform_outl () { &__ia64_outl;}' unless defined(&platform_outl);
    }
    unless(defined(&platform_mmiowb)) {
	eval 'sub platform_mmiowb () { &__ia64_mmiowb;}' unless defined(&platform_mmiowb);
    }
    unless(defined(&platform_readb)) {
	eval 'sub platform_readb () { &__ia64_readb;}' unless defined(&platform_readb);
    }
    unless(defined(&platform_readw)) {
	eval 'sub platform_readw () { &__ia64_readw;}' unless defined(&platform_readw);
    }
    unless(defined(&platform_readl)) {
	eval 'sub platform_readl () { &__ia64_readl;}' unless defined(&platform_readl);
    }
    unless(defined(&platform_readq)) {
	eval 'sub platform_readq () { &__ia64_readq;}' unless defined(&platform_readq);
    }
    unless(defined(&platform_readb_relaxed)) {
	eval 'sub platform_readb_relaxed () { &__ia64_readb_relaxed;}' unless defined(&platform_readb_relaxed);
    }
    unless(defined(&platform_readw_relaxed)) {
	eval 'sub platform_readw_relaxed () { &__ia64_readw_relaxed;}' unless defined(&platform_readw_relaxed);
    }
    unless(defined(&platform_readl_relaxed)) {
	eval 'sub platform_readl_relaxed () { &__ia64_readl_relaxed;}' unless defined(&platform_readl_relaxed);
    }
    unless(defined(&platform_readq_relaxed)) {
	eval 'sub platform_readq_relaxed () { &__ia64_readq_relaxed;}' unless defined(&platform_readq_relaxed);
    }
    unless(defined(&platform_migrate)) {
	eval 'sub platform_migrate () { &machvec_noop_task;}' unless defined(&platform_migrate);
    }
    unless(defined(&platform_msi_init)) {
	eval 'sub platform_msi_init () {(( &ia64_mv_msi_init_t*) &NULL);}' unless defined(&platform_msi_init);
    }
}
1;
