require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PAGE_H)) {
    eval 'sub _ASM_IA64_PAGE_H () {1;}' unless defined(&_ASM_IA64_PAGE_H);
    if(defined(&__KERNEL__)) {
	require 'asm/intrinsics.ph';
	require 'asm/types.ph';
	eval 'sub RGN_SHIFT () {(61);}' unless defined(&RGN_SHIFT);
	eval 'sub RGN_BASE {
	    my($r) = @_;
    	    eval q(( &__IA64_UL_CONST($r)<< &RGN_SHIFT));
	}' unless defined(&RGN_BASE);
	eval 'sub RGN_BITS () {( &RGN_BASE(-1));}' unless defined(&RGN_BITS);
	eval 'sub RGN_KERNEL () {7;}' unless defined(&RGN_KERNEL);
	eval 'sub RGN_UNCACHED () {6;}' unless defined(&RGN_UNCACHED);
	eval 'sub RGN_GATE () {5;}' unless defined(&RGN_GATE);
	eval 'sub RGN_HPAGE () {4;}' unless defined(&RGN_HPAGE);
	if(defined( &CONFIG_IA64_PAGE_SIZE_4KB)) {
	    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
	}
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_8KB)) {
	    eval 'sub PAGE_SHIFT () {13;}' unless defined(&PAGE_SHIFT);
	}
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_16KB)) {
	    eval 'sub PAGE_SHIFT () {14;}' unless defined(&PAGE_SHIFT);
	}
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_64KB)) {
	    eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
	} else {
	    die("Unsupported\ page\ size\!");
	}
	eval 'sub PAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
	eval 'sub PAGE_MASK () {(~( &PAGE_SIZE - 1));}' unless defined(&PAGE_MASK);
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr) +  &PAGE_SIZE - 1) &  &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub PERCPU_PAGE_SHIFT () {16;}' unless defined(&PERCPU_PAGE_SHIFT);
	eval 'sub PERCPU_PAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &PERCPU_PAGE_SHIFT);}' unless defined(&PERCPU_PAGE_SIZE);
	if(defined(&CONFIG_HUGETLB_PAGE)) {
	    eval 'sub HPAGE_REGION_BASE () { &RGN_BASE( &RGN_HPAGE);}' unless defined(&HPAGE_REGION_BASE);
	    eval 'sub HPAGE_SHIFT () { &hpage_shift;}' unless defined(&HPAGE_SHIFT);
	    eval 'sub HPAGE_SHIFT_DEFAULT () {28;}' unless defined(&HPAGE_SHIFT_DEFAULT);
	    eval 'sub HPAGE_SIZE () {( &__IA64_UL_CONST(1) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
	    eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
	    eval 'sub HAVE_ARCH_HUGETLB_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_HUGETLB_UNMAPPED_AREA);
	    eval 'sub ARCH_HAS_HUGEPAGE_ONLY_RANGE () {1;}' unless defined(&ARCH_HAS_HUGEPAGE_ONLY_RANGE);
	    eval 'sub ARCH_HAS_PREPARE_HUGEPAGE_RANGE () {1;}' unless defined(&ARCH_HAS_PREPARE_HUGEPAGE_RANGE);
	    eval 'sub ARCH_HAS_HUGETLB_FREE_PGD_RANGE () {1;}' unless defined(&ARCH_HAS_HUGETLB_FREE_PGD_RANGE);
	}
	if(defined(&__ASSEMBLY__)) {
	    eval 'sub __pa {
	        my($x) = @_;
    		eval q((($x) -  &PAGE_OFFSET));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        my($x) = @_;
    		eval q((($x) +  &PAGE_OFFSET));
	    }' unless defined(&__va);
	} else {
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    eval 'sub clear_user_page {
	        my($addr, $vaddr, $page) = @_;
    		eval q( &do {  &clear_page($addr);  &flush_dcache_page($page); }  &while (0));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        my($to, $from, $vaddr, $page) = @_;
    		eval q( &do {  &copy_page(($to), ($from));  &flush_dcache_page($page); }  &while (0));
	    }' unless defined(&copy_user_page);
	    eval 'sub alloc_zeroed_user_highpage {
	        my($vma, $vaddr) = @_;
    		eval q(({ 1;  &if ( &page)  &flush_dcache_page( &page);  &page; }));
	    }' unless defined(&alloc_zeroed_user_highpage);
	    eval 'sub __HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE () {1;}' unless defined(&__HAVE_ARCH_ALLOC_ZEROED_USER_HIGHPAGE);
	    eval 'sub virt_addr_valid {
	        my($kaddr) = @_;
    		eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_addr_valid);
	    if(defined(&CONFIG_VIRTUAL_MEM_MAP)) {
	    }
 elsif(defined( &CONFIG_FLATMEM)) {
		eval 'sub ia64_pfn_valid {
		    my($pfn) = @_;
    		    eval q(1);
		}' unless defined(&ia64_pfn_valid);
	    }
	    if(defined(&CONFIG_VIRTUAL_MEM_MAP)) {
		if(defined(&CONFIG_DISCONTIGMEM)) {
		    eval 'sub page_to_pfn {
		        my($page) = @_;
    			eval q(( ($page -  &vmem_map)));
		    }' unless defined(&page_to_pfn);
		    eval 'sub pfn_to_page {
		        my($pfn) = @_;
    			eval q(( &vmem_map + ($pfn)));
		    }' unless defined(&pfn_to_page);
		}
	    }
	    if(defined( &CONFIG_FLATMEM) || defined( &CONFIG_SPARSEMEM)) {
		require 'asm-generic/memory_model.ph';
	    }
	    if(defined(&CONFIG_FLATMEM)) {
		eval 'sub pfn_valid {
		    my($pfn) = @_;
    		    eval q(((($pfn) <  &max_mapnr)  &&  &ia64_pfn_valid($pfn)));
		}' unless defined(&pfn_valid);
	    }
 elsif(defined( &CONFIG_DISCONTIGMEM)) {
		eval 'sub pfn_valid {
		    my($pfn) = @_;
    		    eval q(((($pfn) >=  &min_low_pfn)  && (($pfn) <  &max_low_pfn)  &&  &ia64_pfn_valid($pfn)));
		}' unless defined(&pfn_valid);
	    }
	    eval 'sub page_to_phys {
	        my($page) = @_;
    		eval q(( &page_to_pfn($page) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	    eval 'sub virt_to_page {
	        my($kaddr) = @_;
    		eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	    }' unless defined(&virt_to_page);
	    eval 'sub pfn_to_kaddr {
	        my($pfn) = @_;
    		eval q( &__va(($pfn) <<  &PAGE_SHIFT));
	    }' unless defined(&pfn_to_kaddr);
	    eval 'sub __pa {
	        my($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = 0;  ($_v->{l});}));
	    }' unless defined(&__pa);
	    eval 'sub __va {
	        my($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg}) = -1;  ($_v->{p});}));
	    }' unless defined(&__va);
	    eval 'sub REGION_NUMBER {
	        my($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{reg});}));
	    }' unless defined(&REGION_NUMBER);
	    eval 'sub REGION_OFFSET {
	        my($x) = @_;
    		eval q(({ &ia64_va  &_v;  ($_v->{l}) = ($x);  ($_v->{f}->{off});}));
	    }' unless defined(&REGION_OFFSET);
	    if(defined(&CONFIG_HUGETLB_PAGE)) {
		eval 'sub htlbpage_to_page {
		    my($x) = @_;
    		    eval q(((  &REGION_NUMBER($x) << 61) | ( &REGION_OFFSET($x) >> ( &HPAGE_SHIFT- &PAGE_SHIFT))));
		}' unless defined(&htlbpage_to_page);
		eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
		eval 'sub is_hugepage_only_range {
		    my($mm, $addr, $len) = @_;
    		    eval q(( &REGION_NUMBER($addr) ==  &RGN_HPAGE ||  &REGION_NUMBER(($addr)+($len)-1) ==  &RGN_HPAGE));
		}' unless defined(&is_hugepage_only_range);
	    }
	    eval 'sub get_order {
	        my($size) = @_;
    		eval q({ my $d = $size - 1; my $order;  $order =  &ia64_getf_exp( $d);  $order =  $order -  &PAGE_SHIFT - 0xffff + 1;  &if ( $order < 0)  $order = 0;  $order; });
	    }' unless defined(&get_order);
	}
	if(defined(&STRICT_MM_TYPECHECKS)) {
	    if(defined(&CONFIG_PGTABLE_4)) {
	    }
	    eval 'sub pte_val {
	        my($x) = @_;
    		eval q((($x). &pte));
	    }' unless defined(&pte_val);
	    eval 'sub pmd_val {
	        my($x) = @_;
    		eval q((($x). &pmd));
	    }' unless defined(&pmd_val);
	    if(defined(&CONFIG_PGTABLE_4)) {
		eval 'sub pud_val {
		    my($x) = @_;
    		    eval q((($x). &pud));
		}' unless defined(&pud_val);
	    }
	    eval 'sub pgd_val {
	        my($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	} else {
	    unless(defined(&__ASSEMBLY__)) {
	    }
	    eval 'sub pte_val {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&pte_val);
	    eval 'sub pmd_val {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&pmd_val);
	    eval 'sub pgd_val {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&pgd_val);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&__pte);
	    eval 'sub __pgd {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&__pgd);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q(($x));
	    }' unless defined(&__pgprot);
	}
	eval 'sub PAGE_OFFSET () { &RGN_BASE( &RGN_KERNEL);}' unless defined(&PAGE_OFFSET);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC | ((( ($current->{personality}) &  &READ_IMPLIES_EXEC) != 0) ?  &VM_EXEC : 0));}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
