require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PERCPU_H)) {
    eval 'sub _ASM_IA64_PERCPU_H () {1;}' unless defined(&_ASM_IA64_PERCPU_H);
    eval 'sub PERCPU_ENOUGH_ROOM () { &PERCPU_PAGE_SIZE;}' unless defined(&PERCPU_ENOUGH_ROOM);
    if(defined(&__ASSEMBLY__)) {
	eval 'sub THIS_CPU {
	    my($var) = @_;
    	    eval q(( &per_cpu__$var));
	}' unless defined(&THIS_CPU);
    } else {
	require 'linux/threads.ph';
	if(defined(&HAVE_MODEL_SMALL_ATTRIBUTE)) {
	    eval 'sub __SMALL_ADDR_AREA () { &__attribute__(( &__model__ ( &__small__)));}' unless defined(&__SMALL_ADDR_AREA);
	} else {
	    eval 'sub __SMALL_ADDR_AREA () {1;}' unless defined(&__SMALL_ADDR_AREA);
	}
	eval 'sub DECLARE_PER_CPU {
	    my($type, $name) = @_;
    	    eval q( &extern  &__SMALL_ADDR_AREA  &__typeof__($type)  &per_cpu__$name);
	}' unless defined(&DECLARE_PER_CPU);
	eval 'sub DEFINE_PER_CPU {
	    my($type, $name) = @_;
    	    eval q( &__attribute__(( &__section__(\\".data.percpu\\")))  &__SMALL_ADDR_AREA  &__typeof__($type)  &per_cpu__$name);
	}' unless defined(&DEFINE_PER_CPU);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub per_cpu_offset {
	        my($x) = @_;
    		eval q(( &__per_cpu_offset($x)));
	    }' unless defined(&per_cpu_offset);
	    eval 'sub per_cpu {
	        my($var, $cpu) = @_;
    		eval q((* &RELOC_HIDE( &per_cpu__$var,  $__per_cpu_offset[$cpu])));
	    }' unless defined(&per_cpu);
	    eval 'sub __get_cpu_var {
	        my($var) = @_;
    		eval q((* &RELOC_HIDE( &per_cpu__$var,  &__ia64_per_cpu_var( &local_per_cpu_offset))));
	    }' unless defined(&__get_cpu_var);
	    eval 'sub __raw_get_cpu_var {
	        my($var) = @_;
    		eval q((* &RELOC_HIDE( &per_cpu__$var,  &__ia64_per_cpu_var( &local_per_cpu_offset))));
	    }' unless defined(&__raw_get_cpu_var);
	} else {
	    eval 'sub per_cpu {
	        my($var, $cpu) = @_;
    		eval q((*(( &void)($cpu),  &per_cpu__$var)));
	    }' unless defined(&per_cpu);
	    eval 'sub __get_cpu_var {
	        my($var) = @_;
    		eval q( &per_cpu__$var);
	    }' unless defined(&__get_cpu_var);
	    eval 'sub __raw_get_cpu_var {
	        my($var) = @_;
    		eval q( &per_cpu__$var);
	    }' unless defined(&__raw_get_cpu_var);
	    eval 'sub per_cpu_init () {
	        eval q(( &__phys_per_cpu_start));
	    }' unless defined(&per_cpu_init);
	}
	eval 'sub EXPORT_PER_CPU_SYMBOL {
	    my($var) = @_;
    	    eval q( &EXPORT_SYMBOL( &per_cpu__$var));
	}' unless defined(&EXPORT_PER_CPU_SYMBOL);
	eval 'sub EXPORT_PER_CPU_SYMBOL_GPL {
	    my($var) = @_;
    	    eval q( &EXPORT_SYMBOL_GPL( &per_cpu__$var));
	}' unless defined(&EXPORT_PER_CPU_SYMBOL_GPL);
	eval 'sub __ia64_per_cpu_var {
	    my($var) = @_;
    	    eval q(( &per_cpu__$var));
	}' unless defined(&__ia64_per_cpu_var);
    }
}
1;
