require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PROCESSOR_H)) {
    eval 'sub _ASM_IA64_PROCESSOR_H () {1;}' unless defined(&_ASM_IA64_PROCESSOR_H);
    require 'asm/intrinsics.ph';
    require 'asm/kregs.ph';
    require 'asm/ptrace.ph';
    require 'asm/ustack.ph';
    eval 'sub IA64_NUM_DBG_REGS () {8;}' unless defined(&IA64_NUM_DBG_REGS);
    eval 'sub IA64_NUM_PMC_REGS () {64;}' unless defined(&IA64_NUM_PMC_REGS);
    eval 'sub IA64_NUM_PMD_REGS () {64;}' unless defined(&IA64_NUM_PMD_REGS);
    eval 'sub DEFAULT_MAP_BASE () { &__IA64_UL_CONST(0x2000000000000000);}' unless defined(&DEFAULT_MAP_BASE);
    eval 'sub DEFAULT_TASK_SIZE () { &__IA64_UL_CONST(0xa000000000000000);}' unless defined(&DEFAULT_TASK_SIZE);
    eval 'sub TASK_SIZE () {( ($current->{thread}->{task_size}));}' unless defined(&TASK_SIZE);
    eval 'sub TASK_UNMAPPED_BASE () {( ($current->{thread}->{map_base}));}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub IA64_THREAD_FPH_VALID () {( &__IA64_UL(1) << 0);}' unless defined(&IA64_THREAD_FPH_VALID);
    eval 'sub IA64_THREAD_DBG_VALID () {( &__IA64_UL(1) << 1);}' unless defined(&IA64_THREAD_DBG_VALID);
    eval 'sub IA64_THREAD_PM_VALID () {( &__IA64_UL(1) << 2);}' unless defined(&IA64_THREAD_PM_VALID);
    eval 'sub IA64_THREAD_UAC_NOPRINT () {( &__IA64_UL(1) << 3);}' unless defined(&IA64_THREAD_UAC_NOPRINT);
    eval 'sub IA64_THREAD_UAC_SIGBUS () {( &__IA64_UL(1) << 4);}' unless defined(&IA64_THREAD_UAC_SIGBUS);
    eval 'sub IA64_THREAD_MIGRATION () {( &__IA64_UL(1) << 5);}' unless defined(&IA64_THREAD_MIGRATION);
    eval 'sub IA64_THREAD_FPEMU_NOPRINT () {( &__IA64_UL(1) << 6);}' unless defined(&IA64_THREAD_FPEMU_NOPRINT);
    eval 'sub IA64_THREAD_FPEMU_SIGFPE () {( &__IA64_UL(1) << 7);}' unless defined(&IA64_THREAD_FPEMU_SIGFPE);
    eval 'sub IA64_THREAD_UAC_SHIFT () {3;}' unless defined(&IA64_THREAD_UAC_SHIFT);
    eval 'sub IA64_THREAD_UAC_MASK () {( &IA64_THREAD_UAC_NOPRINT |  &IA64_THREAD_UAC_SIGBUS);}' unless defined(&IA64_THREAD_UAC_MASK);
    eval 'sub IA64_THREAD_FPEMU_SHIFT () {6;}' unless defined(&IA64_THREAD_FPEMU_SHIFT);
    eval 'sub IA64_THREAD_FPEMU_MASK () {( &IA64_THREAD_FPEMU_NOPRINT |  &IA64_THREAD_FPEMU_SIGFPE);}' unless defined(&IA64_THREAD_FPEMU_MASK);
    eval 'sub IA64_NSEC_PER_CYC_SHIFT () {30;}' unless defined(&IA64_NSEC_PER_CYC_SHIFT);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/cache.ph';
	require 'linux/compiler.ph';
	require 'linux/threads.ph';
	require 'linux/types.ph';
	require 'asm/fpu.ph';
	require 'asm/page.ph';
	require 'asm/percpu.ph';
	require 'asm/rse.ph';
	require 'asm/unwind.ph';
	require 'asm/atomic.ph';
	if(defined(&CONFIG_NUMA)) {
	    require 'asm/nodedata.ph';
	}
	if(defined(&CONFIG_SMP)) {
	}
	if(defined(&CONFIG_NUMA)) {
	}
	eval 'sub local_cpu_data () {(& &__ia64_per_cpu_var( &cpu_info));}' unless defined(&local_cpu_data);
	eval 'sub cpu_data {
	    my($cpu) = @_;
    	    eval q(( &per_cpu( &cpu_info, $cpu)));
	}' unless defined(&cpu_data);
	eval 'sub SET_UNALIGN_CTL {
	    my($task,$value) = @_;
    	    eval q(({ ($task)-> ($thread->{flags}) = ((($task)-> ($thread->{flags}) & ~ &IA64_THREAD_UAC_MASK) | ((($value) <<  &IA64_THREAD_UAC_SHIFT) &  &IA64_THREAD_UAC_MASK)); 0; }));
	}' unless defined(&SET_UNALIGN_CTL);
	eval 'sub GET_UNALIGN_CTL {
	    my($task,$addr) = @_;
    	    eval q(({  &put_user((($task)-> ($thread->{flags}) &  &IA64_THREAD_UAC_MASK) >>  &IA64_THREAD_UAC_SHIFT, (\'int\'  &__user *) ($addr)); }));
	}' unless defined(&GET_UNALIGN_CTL);
	eval 'sub SET_FPEMU_CTL {
	    my($task,$value) = @_;
    	    eval q(({ ($task)-> ($thread->{flags}) = ((($task)-> ($thread->{flags}) & ~ &IA64_THREAD_FPEMU_MASK) | ((($value) <<  &IA64_THREAD_FPEMU_SHIFT) &  &IA64_THREAD_FPEMU_MASK)); 0; }));
	}' unless defined(&SET_FPEMU_CTL);
	eval 'sub GET_FPEMU_CTL {
	    my($task,$addr) = @_;
    	    eval q(({  &put_user((($task)-> ($thread->{flags}) &  &IA64_THREAD_FPEMU_MASK) >>  &IA64_THREAD_FPEMU_SHIFT, (\'int\'  &__user *) ($addr)); }));
	}' unless defined(&GET_FPEMU_CTL);
	if(defined(&CONFIG_IA32_SUPPORT)) {
	    eval 'sub desc_empty {
	        my($desc) = @_;
    		eval q((!(($desc)-> &a + ($desc)-> &b)));
	    }' unless defined(&desc_empty);
	    eval 'sub desc_equal {
	        my($desc1, $desc2) = @_;
    		eval q(((($desc1)-> &a == ($desc2)-> &a)  && (($desc1)-> &b == ($desc2)-> &b)));
	    }' unless defined(&desc_equal);
	    eval 'sub GDT_ENTRY_TLS_ENTRIES () {3;}' unless defined(&GDT_ENTRY_TLS_ENTRIES);
	    eval 'sub GDT_ENTRY_TLS_MIN () {6;}' unless defined(&GDT_ENTRY_TLS_MIN);
	    eval 'sub GDT_ENTRY_TLS_MAX () {( &GDT_ENTRY_TLS_MIN +  &GDT_ENTRY_TLS_ENTRIES - 1);}' unless defined(&GDT_ENTRY_TLS_MAX);
	    eval 'sub TLS_SIZE () {( &GDT_ENTRY_TLS_ENTRIES * 8);}' unless defined(&TLS_SIZE);
	}
	if(defined(&CONFIG_IA32_SUPPORT)) {
	    eval 'sub INIT_THREAD_IA32 () {. &eflag = 0, . &fsr = 0, . &fcr = 0x17800000037f, . &fir = 0, . &fdr = 0, . &old_k1 = 0, . &old_iob = 0, . &ppl =  &NULL,;}' unless defined(&INIT_THREAD_IA32);
	} else {
	    eval 'sub INIT_THREAD_IA32 () {1;}' unless defined(&INIT_THREAD_IA32);
	}
	if(defined(&CONFIG_PERFMON)) {
	    eval 'sub INIT_THREAD_PM () {. &pmcs = {0, }, . &pmds = {0, }, . &pfm_context =  &NULL, . &pfm_needs_checking = 0,;}' unless defined(&INIT_THREAD_PM);
	} else {
	    eval 'sub INIT_THREAD_PM () {1;}' unless defined(&INIT_THREAD_PM);
	}
	eval 'sub INIT_THREAD () {{ . &flags = 0, . &on_ustack = 0, . &ksp = 0, . &map_base =  &DEFAULT_MAP_BASE, . &rbs_bot =  &STACK_TOP -  &DEFAULT_USER_STACK_SIZE, . &task_size =  &DEFAULT_TASK_SIZE, . &last_fph_cpu = -1,  &INIT_THREAD_IA32  &INIT_THREAD_PM . &dbr = {0, }, . &ibr = {0, }, . &fph = {{{{0}}}, } };}' unless defined(&INIT_THREAD);
	eval 'sub start_thread {
	    my($regs,$new_ip,$new_sp) = @_;
    	    eval q( &do {  &set_fs( &USER_DS);  ($regs->{cr_ipsr}) = (( ($regs->{cr_ipsr}) | ( &IA64_PSR_BITS_TO_SET |  &IA64_PSR_CPL)) & ~( &IA64_PSR_BITS_TO_CLEAR |  &IA64_PSR_RI |  &IA64_PSR_IS));  ($regs->{cr_iip}) = $new_ip;  ($regs->{ar_rsc}) = 0xf;  ($regs->{ar_rnat}) = 0;  ($regs->{ar_bspstore}) =  ($current->{thread}->{rbs_bot});  ($regs->{ar_fpsr}) =  &FPSR_DEFAULT;  ($regs->{loadrs}) = 0;  ($regs->{r8}) =  ($current->{mm}->{dumpable});  ($regs->{r12}) = $new_sp - 16;  &if ( &unlikely(! ($current->{mm}->{dumpable}))) {  ($regs->{ar_pfs}) = 0;  ($regs->{b0}) = 0;  ($regs->{pr}) = 0;  ($regs->{r1}) = 0;  ($regs->{r9})  = 0;  ($regs->{r11}) = 0;  ($regs->{r13}) = 0;  ($regs->{r15}) = 0; } }  &while (0));
	}' unless defined(&start_thread);
	eval 'sub release_thread {
	    my($dead_task) = @_;
    	    eval q();
	}' unless defined(&release_thread);
	eval 'sub prepare_to_copy {
	    my($tsk) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&prepare_to_copy);
	eval 'sub KSTK_EIP {
	    my($tsk) = @_;
    	    eval q(({ 1;  ($_regs->{cr_iip}) +  &ia64_psr( &_regs)-> &ri; }));
	}' unless defined(&KSTK_EIP);
	eval 'sub KSTK_ESP {
	    my($tsk) = @_;
    	    eval q((($tsk)-> ($thread->{ksp})));
	}' unless defined(&KSTK_ESP);
	eval 'sub ia64_get_kr {
	    my($regnum) = @_;
    	    eval q(({ \'unsigned long r\' = 0;  &switch ($regnum) {  &case 0:  &r =  &ia64_getreg( &_IA64_REG_AR_KR0);  &break;  &case 1:  &r =  &ia64_getreg( &_IA64_REG_AR_KR1);  &break;  &case 2:  &r =  &ia64_getreg( &_IA64_REG_AR_KR2);  &break;  &case 3:  &r =  &ia64_getreg( &_IA64_REG_AR_KR3);  &break;  &case 4:  &r =  &ia64_getreg( &_IA64_REG_AR_KR4);  &break;  &case 5:  &r =  &ia64_getreg( &_IA64_REG_AR_KR5);  &break;  &case 6:  &r =  &ia64_getreg( &_IA64_REG_AR_KR6);  &break;  &case 7:  &r =  &ia64_getreg( &_IA64_REG_AR_KR7);  &break;  &default:  &ia64_getreg_unknown_kr();  &break; }  &r; }));
	}' unless defined(&ia64_get_kr);
	eval 'sub ia64_set_kr {
	    my($regnum, $r) = @_;
    	    eval q(({  &switch ($regnum) {  &case 0:  &ia64_setreg( &_IA64_REG_AR_KR0, $r);  &break;  &case 1:  &ia64_setreg( &_IA64_REG_AR_KR1, $r);  &break;  &case 2:  &ia64_setreg( &_IA64_REG_AR_KR2, $r);  &break;  &case 3:  &ia64_setreg( &_IA64_REG_AR_KR3, $r);  &break;  &case 4:  &ia64_setreg( &_IA64_REG_AR_KR4, $r);  &break;  &case 5:  &ia64_setreg( &_IA64_REG_AR_KR5, $r);  &break;  &case 6:  &ia64_setreg( &_IA64_REG_AR_KR6, $r);  &break;  &case 7:  &ia64_setreg( &_IA64_REG_AR_KR7, $r);  &break;  &default:  &ia64_setreg_unknown_kr();  &break; } }));
	}' unless defined(&ia64_set_kr);
	eval 'sub ia64_is_local_fpu_owner {
	    my($t) = @_;
    	    eval q(({ 1; ( ($__ia64_islfo_task->{thread}->{last_fph_cpu}) ==  &smp_processor_id()  &&  &__ia64_islfo_task ==   &ia64_get_kr( &IA64_KR_FPU_OWNER)); }));
	}' unless defined(&ia64_is_local_fpu_owner);
	eval 'sub ia64_set_local_fpu_owner {
	    my($t) = @_;
    	    eval q( &do { 1;  ($__ia64_slfo_task->{thread}->{last_fph_cpu}) =  &smp_processor_id();  &ia64_set_kr( &IA64_KR_FPU_OWNER,   &__ia64_slfo_task); }  &while (0));
	}' unless defined(&ia64_set_local_fpu_owner);
	eval 'sub ia64_drop_fpu {
	    my($t) = @_;
    	    eval q((($t)-> ($thread->{last_fph_cpu}) = -1));
	}' unless defined(&ia64_drop_fpu);
	if(defined(&CONFIG_IA32_SUPPORT)) {
	}
	eval 'sub ia64_fph_enable () {
	    eval q( &do {  &ia64_rsm( &IA64_PSR_DFH);  &ia64_srlz_d(); }  &while (0));
	}' unless defined(&ia64_fph_enable);
	eval 'sub ia64_fph_disable () {
	    eval q( &do {  &ia64_ssm( &IA64_PSR_DFH);  &ia64_srlz_d(); }  &while (0));
	}' unless defined(&ia64_fph_disable);
	eval 'sub ia64_clear_ic {
	    my($void) = @_;
    	    eval q({  &__u64  &psr;  &psr =  &ia64_getreg( &_IA64_REG_PSR);  &ia64_stop();  &ia64_rsm( &IA64_PSR_I |  &IA64_PSR_IC);  &ia64_srlz_i();  &psr; });
	}' unless defined(&ia64_clear_ic);
	eval 'sub ia64_eoi {
	    my($void) = @_;
    	    eval q({  &ia64_setreg( &_IA64_REG_CR_EOI, 0);  &ia64_srlz_d(); });
	}' unless defined(&ia64_eoi);
	eval 'sub cpu_relax () {
	    eval q( &ia64_hint( &ia64_hint_pause));
	}' unless defined(&cpu_relax);
	eval 'sub ia64_get_irr {
	    my($vector) = @_;
    	    eval q({ my $reg = $vector / 64; my $bit = $vector % 64;  &u64  &irr;  &switch ( $reg) {  &case 0:  &irr =  &ia64_getreg( &_IA64_REG_CR_IRR0);  &break;  &case 1:  &irr =  &ia64_getreg( &_IA64_REG_CR_IRR1);  &break;  &case 2:  &irr =  &ia64_getreg( &_IA64_REG_CR_IRR2);  &break;  &case 3:  &irr =  &ia64_getreg( &_IA64_REG_CR_IRR3);  &break; }  &test_bit( $bit,  &irr); });
	}' unless defined(&ia64_get_irr);
	eval 'sub ia64_set_lrr0 {
	    my($val) = @_;
    	    eval q({  &ia64_setreg( &_IA64_REG_CR_LRR0, $val);  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_lrr0);
	eval 'sub ia64_set_lrr1 {
	    my($val) = @_;
    	    eval q({  &ia64_setreg( &_IA64_REG_CR_LRR1, $val);  &ia64_srlz_d(); });
	}' unless defined(&ia64_set_lrr1);
	eval 'sub current_text_addr () {
	    eval q(({  &void * &_pc;  &_pc = ( &void *) &ia64_getreg( &_IA64_REG_IP);  &_pc; }));
	}' unless defined(&current_text_addr);
	eval 'sub ia64_get_ivr {
	    my($void) = @_;
    	    eval q({  &__u64  &r;  &ia64_srlz_d();  &r =  &ia64_getreg( &_IA64_REG_CR_IVR);  &ia64_srlz_d();  &r; });
	}' unless defined(&ia64_get_ivr);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub ia64_set_dbr {
	    my($regnum,$value) = @_;
    	    eval q({  &__ia64_set_dbr($regnum, $value); });
	}' unless defined(&ia64_set_dbr);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub ia64_get_dbr {
	    my($regnum) = @_;
    	    eval q({  &__u64  &retval;  &retval =  &__ia64_get_dbr($regnum);  &retval; });
	}' unless defined(&ia64_get_dbr);
	eval 'sub ia64_rotr {
	    my($w,$n) = @_;
    	    eval q({ ($w >> $n) | ($w << (64- $n)); });
	}' unless defined(&ia64_rotr);
	eval 'sub ia64_rotl {
	    my($w,$n) = @_;
    	    eval q( &ia64_rotr(($w), (64) - ($n)));
	}' unless defined(&ia64_rotl);
	eval 'sub ARCH_HAS_PREFETCH () {1;}' unless defined(&ARCH_HAS_PREFETCH);
	eval 'sub ARCH_HAS_PREFETCHW () {1;}' unless defined(&ARCH_HAS_PREFETCHW);
	eval 'sub ARCH_HAS_SPINLOCK_PREFETCH () {1;}' unless defined(&ARCH_HAS_SPINLOCK_PREFETCH);
	eval 'sub PREFETCH_STRIDE () { &L1_CACHE_BYTES;}' unless defined(&PREFETCH_STRIDE);
	eval 'sub prefetch {
	    my($x) = @_;
    	    eval q({  &ia64_lfetch( &ia64_lfhint_none, $x); });
	}' unless defined(&prefetch);
	eval 'sub prefetchw {
	    my($x) = @_;
    	    eval q({  &ia64_lfetch_excl( &ia64_lfhint_none, $x); });
	}' unless defined(&prefetchw);
	eval 'sub spin_lock_prefetch {
	    my($x) = @_;
    	    eval q( &prefetchw($x));
	}' unless defined(&spin_lock_prefetch);
    }
}
1;
