require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_RWSEM_H)) {
    eval 'sub _ASM_IA64_RWSEM_H () {1;}' unless defined(&_ASM_IA64_RWSEM_H);
    require 'linux/list.ph';
    require 'linux/spinlock.ph';
    require 'asm/intrinsics.ph';
    eval 'sub RWSEM_UNLOCKED_VALUE () { &__IA64_UL_CONST(0x);}' unless defined(&RWSEM_UNLOCKED_VALUE);
    eval 'sub RWSEM_ACTIVE_BIAS () { &__IA64_UL_CONST(0x1);}' unless defined(&RWSEM_ACTIVE_BIAS);
    eval 'sub RWSEM_ACTIVE_MASK () { &__IA64_UL_CONST(0xffffffff);}' unless defined(&RWSEM_ACTIVE_MASK);
    eval 'sub RWSEM_WAITING_BIAS () {- &__IA64_UL_CONST(0x100000000);}' unless defined(&RWSEM_WAITING_BIAS);
    eval 'sub RWSEM_ACTIVE_READ_BIAS () { &RWSEM_ACTIVE_BIAS;}' unless defined(&RWSEM_ACTIVE_READ_BIAS);
    eval 'sub RWSEM_ACTIVE_WRITE_BIAS () {( &RWSEM_WAITING_BIAS +  &RWSEM_ACTIVE_BIAS);}' unless defined(&RWSEM_ACTIVE_WRITE_BIAS);
    eval 'sub __RWSEM_INITIALIZER {
        my($name) = @_;
	    eval q({  &RWSEM_UNLOCKED_VALUE,  &SPIN_LOCK_UNLOCKED,  &LIST_HEAD_INIT(($name). &wait_list) });
    }' unless defined(&__RWSEM_INITIALIZER);
    eval 'sub DECLARE_RWSEM {
        my($name) = @_;
	    eval q(1;
    }' unless defined(&DECLARE_RWSEM);
    eval 'sub init_rwsem {
        my($sem) = @_;
	    eval q({  ($sem->{count}) =  &RWSEM_UNLOCKED_VALUE;  &spin_lock_init( ($sem->{wait_lock}));  &INIT_LIST_HEAD( ($sem->{wait_list})); });
    }' unless defined(&init_rwsem);
    eval 'sub rwsem_atomic_add {
        my($delta, $sem) = @_;
	    eval q( &atomic64_add($delta, ( &atomic64_t *)(($sem)-> &count)));
    }' unless defined(&rwsem_atomic_add);
    eval 'sub rwsem_atomic_update {
        my($delta, $sem) = @_;
	    eval q( &atomic64_add_return($delta, ( &atomic64_t *)(($sem)-> &count)));
    }' unless defined(&rwsem_atomic_update);
    eval 'sub rwsem_is_locked {
        my($sem) = @_;
	    eval q({ ( ($sem->{count}) != 0); });
    }' unless defined(&rwsem_is_locked);
}
1;
