require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_SPINLOCK_H)) {
    eval 'sub _ASM_IA64_SPINLOCK_H () {1;}' unless defined(&_ASM_IA64_SPINLOCK_H);
    require 'linux/compiler.ph';
    require 'linux/kernel.ph';
    require 'asm/atomic.ph';
    require 'asm/bitops.ph';
    require 'asm/intrinsics.ph';
    require 'asm/system.ph';
    eval 'sub __raw_spin_lock_init {
        my($x) = @_;
	    eval q((($x)-> &lock = 0));
    }' unless defined(&__raw_spin_lock_init);
    if(defined(&ASM_SUPPORTED)) {
	eval 'sub IA64_SPINLOCK_CLOBBERS () {"ar.ccv", "ar.pfs", "p14", "p15", "r27", "r28", "r29", "r30", "b6", "memory";}' unless defined(&IA64_SPINLOCK_CLOBBERS);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __raw_spin_lock_flags {
	    my($lock,$flags) = @_;
    	    eval q({  &register  &volatile \'unsigned int\' * &ptr  &asm (\\"r31\\") =  ($lock->{lock});  &else  &endif });
	}' unless defined(&__raw_spin_lock_flags);
	eval 'sub __raw_spin_lock {
	    my($lock) = @_;
    	    eval q( &__raw_spin_lock_flags($lock, 0));
	}' unless defined(&__raw_spin_lock);
    } else {
	eval 'sub __raw_spin_lock_flags {
	    my($lock, $flags) = @_;
    	    eval q( &__raw_spin_lock($lock));
	}' unless defined(&__raw_spin_lock_flags);
	eval 'sub __raw_spin_lock {
	    my($x) = @_;
    	    eval q( &do {  &__u32 * &ia64_spinlock_ptr = ( &__u32 *) ($x);  &__u64  &ia64_spinlock_val;  &ia64_spinlock_val =  &ia64_cmpxchg4_acq( &ia64_spinlock_ptr, 1, 0);  &if ( &unlikely( &ia64_spinlock_val)) {  &do {  &while (* &ia64_spinlock_ptr)  &ia64_barrier();  &ia64_spinlock_val =  &ia64_cmpxchg4_acq( &ia64_spinlock_ptr, 1, 0); }  &while ( &ia64_spinlock_val); } }  &while (0));
	}' unless defined(&__raw_spin_lock);
	eval 'sub __raw_spin_unlock {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); (( &raw_spinlock_t *) $x)-> &lock = 0; }  &while (0));
	}' unless defined(&__raw_spin_unlock);
    }
    eval 'sub __raw_spin_is_locked {
        my($x) = @_;
	    eval q((($x)-> &lock != 0));
    }' unless defined(&__raw_spin_is_locked);
    eval 'sub __raw_spin_trylock {
        my($x) = @_;
	    eval q(( &cmpxchg_acq(($x)-> &lock, 0, 1) == 0));
    }' unless defined(&__raw_spin_trylock);
    eval 'sub __raw_spin_unlock_wait {
        my($lock) = @_;
	    eval q( &do {  &while ( &__raw_spin_is_locked($lock))  &cpu_relax(); }  &while (0));
    }' unless defined(&__raw_spin_unlock_wait);
    eval 'sub __raw_read_can_lock {
        my($rw) = @_;
	    eval q((*( &volatile \'int\' *)($rw) >= 0));
    }' unless defined(&__raw_read_can_lock);
    eval 'sub __raw_write_can_lock {
        my($rw) = @_;
	    eval q((*( &volatile \'int\' *)($rw) == 0));
    }' unless defined(&__raw_write_can_lock);
    eval 'sub __raw_read_lock {
        my($rw) = @_;
	    eval q( &do {  &raw_rwlock_t * &__read_lock_ptr = ;  &while ( &unlikely( &ia64_fetchadd(1,  &__read_lock_ptr,  &acq) < 0)) {  &ia64_fetchadd(-1,  &__read_lock_ptr,  &rel);  &while (*( &volatile \'int\' *) &__read_lock_ptr < 0)  &cpu_relax(); } }  &while (0));
    }' unless defined(&__raw_read_lock);
    eval 'sub __raw_read_unlock {
        my($rw) = @_;
	    eval q( &do {  &raw_rwlock_t * &__read_lock_ptr = ;  &ia64_fetchadd(-1,  &__read_lock_ptr,  &rel); }  &while (0));
    }' unless defined(&__raw_read_unlock);
    if(defined(&ASM_SUPPORTED)) {
	eval 'sub __raw_write_lock {
	    my($rw) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__raw_write_lock);
	eval 'sub __raw_write_trylock {
	    my($rw) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__raw_write_trylock);
	eval 'sub __raw_write_unlock {
	    my($x) = @_;
    	    eval q({  &u8 * &y = ( &u8 *)$x;  &barrier();  &asm  &volatile (\\"st1.rel.nta [%0] = r0\\\\n\\\\t\\" :: \\"r\\"( &y+3) : \\"memory\\" ); });
	}' unless defined(&__raw_write_unlock);
    } else {
	eval 'sub __raw_write_lock {
	    my($l) = @_;
    	    eval q(({  &__u64  &ia64_val,  &ia64_set_val =  &ia64_dep_mi(-1, 0, 31, 1);  &__u32 * &ia64_write_lock_ptr = ( &__u32 *) ($l);  &do {  &while (* &ia64_write_lock_ptr)  &ia64_barrier();  &ia64_val =  &ia64_cmpxchg4_acq( &ia64_write_lock_ptr,  &ia64_set_val, 0); }  &while ( &ia64_val); }));
	}' unless defined(&__raw_write_lock);
	eval 'sub __raw_write_trylock {
	    my($rw) = @_;
    	    eval q(({  &__u64  &ia64_val;  &__u64  &ia64_set_val =  &ia64_dep_mi(-1, 0, 31,1);  &ia64_val =  &ia64_cmpxchg4_acq(( &__u32 *)($rw),  &ia64_set_val, 0); ( &ia64_val == 0); }));
	}' unless defined(&__raw_write_trylock);
	eval 'sub __raw_write_unlock {
	    my($x) = @_;
    	    eval q({  &barrier();  ($x->{write_lock}) = 0; });
	}' unless defined(&__raw_write_unlock);
    }
    eval 'sub __raw_read_trylock {
        my($x) = @_;
	    eval q({ \'union union\' {  &raw_rwlock_t  &lock;  &__u32  &word; }  &old,  &new;  ($old->{lock}) =  ($new->{lock}) = *$x;  ($old->{lock}->{write_lock}) =  ($new->{lock}->{write_lock}) = 0; ++ ($new->{lock}->{read_counter}); ( &u32) &ia64_cmpxchg4_acq(( &__u32 *)($x),  ($new->{word}),  ($old->{word})) ==  ($old->{word}); });
    }' unless defined(&__raw_read_trylock);
}
1;
