require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_TOPOLOGY_H)) {
    eval 'sub _ASM_IA64_TOPOLOGY_H () {1;}' unless defined(&_ASM_IA64_TOPOLOGY_H);
    require 'asm/acpi.ph';
    require 'asm/numa.ph';
    require 'asm/smp.ph';
    if(defined(&CONFIG_NUMA)) {
	eval 'sub PENALTY_FOR_NODE_WITH_CPUS () {255;}' unless defined(&PENALTY_FOR_NODE_WITH_CPUS);
	eval 'sub RECLAIM_DISTANCE () {15;}' unless defined(&RECLAIM_DISTANCE);
	eval 'sub cpu_to_node {
	    my($cpu) = @_;
    	    eval q(( $cpu_to_node_map[$cpu]));
	}' unless defined(&cpu_to_node);
	eval 'sub node_to_cpumask {
	    my($node) = @_;
    	    eval q(( $node_to_cpu_mask[$node]));
	}' unless defined(&node_to_cpumask);
	eval 'sub parent_node {
	    my($nid) = @_;
    	    eval q(($nid));
	}' unless defined(&parent_node);
	eval 'sub node_to_first_cpu {
	    my($node) = @_;
    	    eval q(( &first_cpu( &node_to_cpumask($node))));
	}' unless defined(&node_to_first_cpu);
	eval 'sub pcibus_to_node {
	    my($bus) = @_;
    	    eval q( &PCI_CONTROLLER($bus)-> &node);
	}' unless defined(&pcibus_to_node);
	eval 'sub SD_CPU_INIT () { { . &span =  &CPU_MASK_NONE, . &parent =  &NULL, . &groups =  &NULL, . &min_interval = 1, . &max_interval = 4, . &busy_factor = 64, . &imbalance_pct = 125, . &per_cpu_gain = 100, . &cache_nice_tries = 2, . &busy_idx = 2, . &idle_idx = 1, . &newidle_idx = 2, . &wake_idx = 1, . &forkexec_idx = 1, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_NEWIDLE |  &SD_BALANCE_EXEC |  &SD_WAKE_AFFINE, . &last_balance =  &jiffies, . &balance_interval = 1, . &nr_balance_failed = 0, };}' unless defined(&SD_CPU_INIT);
	eval 'sub SD_NODE_INIT () { { . &span =  &CPU_MASK_NONE, . &parent =  &NULL, . &groups =  &NULL, . &min_interval = 8, . &max_interval = 8*( &min( &num_online_cpus(), 32)), . &busy_factor = 64, . &imbalance_pct = 125, . &cache_nice_tries = 2, . &busy_idx = 3, . &idle_idx = 2, . &newidle_idx = 0, . &wake_idx = 1, . &forkexec_idx = 1, . &per_cpu_gain = 100, . &flags =  &SD_LOAD_BALANCE |  &SD_BALANCE_EXEC |  &SD_BALANCE_FORK |  &SD_WAKE_BALANCE, . &last_balance =  &jiffies, . &balance_interval = 64, . &nr_balance_failed = 0, };}' unless defined(&SD_NODE_INIT);
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub topology_physical_package_id {
	    my($cpu) = @_;
    	    eval q(( &cpu_data($cpu)-> &socket_id));
	}' unless defined(&topology_physical_package_id);
	eval 'sub topology_core_id {
	    my($cpu) = @_;
    	    eval q(( &cpu_data($cpu)-> &core_id));
	}' unless defined(&topology_core_id);
	eval 'sub topology_core_siblings {
	    my($cpu) = @_;
    	    eval q(( $cpu_core_map[$cpu]));
	}' unless defined(&topology_core_siblings);
	eval 'sub topology_thread_siblings {
	    my($cpu) = @_;
    	    eval q(( $cpu_sibling_map[$cpu]));
	}' unless defined(&topology_thread_siblings);
	eval 'sub smt_capable () {
	    eval q(( &smp_num_siblings > 1));
	}' unless defined(&smt_capable);
    }
    require 'asm-generic/topology.ph';
}
1;
